(* ========================================================================= *)
(*                                                                           *)
(*        		   Application.ml					      *)
(*                                                                           *)
(*        (c) Copyright, Sidi Mohamed BEILLAHI, Muhammad Umair Siddique      *)
(*                       2016                                                *)
(*                       Hardware Verification Group,                        *)
(*                       Concordia University                                *)
(*                                                                           *)
(*     Contact: <beillahi@ece.concordia.ca>,				     *)
(*		<muh_sidd@ece.concordia.ca>                                  *)
(*       	                                 			     *)
(*                                                                           *)
(* Last update: April 22, 2016                                               *)
(*                                                                           *)
(* ========================================================================= *)


(*-------------REQUIRED LIBRARIES ---------------------*)



needs "Stability_Resonance.ml";;


(*-----------------------------------------------------*)
(*----------------Formalization------------------------*)
(*-----------------------------------------------------*)
(*-------------------------------------------------------------------*)
(*---------------------PANDA Vernier Resonator-----------------------*)
(*-------------------------------------------------------------------*)

let panda_help = COMPLEX_FIELD `  (((--ii * s1) *
 csqrt (csqrt (e pow n)) * cr * csqrt (csqrt (e pow n)) * --ii *
 s2) * (Cx (&1) + (cr * csqrt (er pow nr) * csqrt (er pow nr)) *
 cl * csqrt (el pow nl) * csqrt (el pow nl) +
 --(cl * csqrt (el pow nl) * csqrt (el pow nl)) -
 cr * csqrt (er pow nr) * csqrt (er pow nr)) +
 ((--ii * s1) * csqrt (csqrt (e pow n)) * (--ii * sr) *
 csqrt (er pow nr) * csqrt (er pow nr) * (--ii * sr) *
 csqrt (csqrt (e pow n)) * --ii * s2) *
 (Cx (&1) + --(cl * csqrt (el pow nl) * csqrt (el pow nl)))) =
 (cr pow 2 + sr pow 2) * s1 * s2 * csqrt (er pow nr) pow 2 *  
 (csqrt (csqrt (e pow n))) pow 2 - (cr pow 2 + sr pow 2) * 
 s1 * s2 * cl * csqrt (el pow nl) pow 2 * csqrt (er pow nr) pow 2 * 
 (csqrt (csqrt (e pow n))) pow 2 - cr * s1 * s2 * 
 (csqrt (csqrt (e pow n))) pow 2 + cr * cl * s1 * s2 * 
 csqrt (el pow nl) pow 2 * (csqrt (csqrt (e pow n))) pow 2 /\
c1 * (Cx (&1) + ((c1 * csqrt (csqrt (e pow n)) * cr * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * cl * csqrt (csqrt (e pow n))) * cr *
 csqrt (er pow nr) * csqrt (er pow nr) + (c1 * csqrt (csqrt (e pow n)) *
 cr * csqrt (csqrt (e pow n)) * c2 * csqrt (csqrt (e pow n)) * cl *
 csqrt (csqrt (e pow n))) * cl * csqrt (el pow nl) * csqrt (el pow nl)) +
 --Cx (&0) - (c1 * csqrt (csqrt (e pow n)) * cr * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * cl * csqrt (csqrt (e pow n))) * (cr * 
 csqrt (er pow nr) * csqrt (er pow nr)) * cl * csqrt (el pow nl) *
 csqrt (el pow nl) + ((c1 * csqrt (csqrt (e pow n)) * cr *
 csqrt (csqrt (e pow n)) * c2 * csqrt (csqrt (e pow n)) * (--ii * sl) *
 csqrt (el pow nl) * csqrt (el pow nl) * (--ii * sl) * csqrt (csqrt (e pow n))) *
 cr * csqrt (er pow nr) * csqrt (er pow nr) + --Cx (&0) + ((c1 *
 csqrt (csqrt (e pow n)) * (--ii * sr) * csqrt (er pow nr) * csqrt (er pow nr) *
 (--ii * sr) * csqrt (csqrt (e pow n)) * c2 * csqrt (csqrt (e pow n)) *
 cl * csqrt (csqrt (e pow n))) * cl * csqrt (el pow nl) * csqrt (el pow nl) +
 --Cx (&0) + ((cr * csqrt (er pow nr) * csqrt (er pow nr)) *  cl *
 csqrt (el pow nl) * csqrt (el pow nl) + --(cl * csqrt (el pow nl) * 
 csqrt (el pow nl)) - cr * csqrt (er pow nr) * csqrt (er pow nr)) -
 c1 * csqrt (csqrt (e pow n)) * (--ii * sr) * csqrt (er pow nr) *
 csqrt (er pow nr) * (--ii * sr) * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * (--ii * sl) * csqrt (el pow nl) *
 csqrt (el pow nl) * (--ii * sl) * csqrt (csqrt (e pow n)) - c1 *
 csqrt (csqrt (e pow n)) * (--ii * sr) * csqrt (er pow nr) *
 csqrt (er pow nr) * (--ii * sr) * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * cl * csqrt (csqrt (e pow n))) -
 c1 * csqrt (csqrt (e pow n)) * cr * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * (--ii * sl) * csqrt (el pow nl) *
 csqrt (el pow nl) * (--ii * sl) * csqrt (csqrt (e pow n))) -
 c1 * csqrt (csqrt (e pow n)) * cr * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * cl * csqrt (csqrt (e pow n))) +
 ((--ii * s1) * csqrt (csqrt (e pow n)) * cr * csqrt (csqrt (e pow n)) * c2 *
 csqrt (csqrt (e pow n)) * cl * csqrt (csqrt (e pow n)) * --ii * s1) * (Cx (&1) +
 (cr * csqrt (er pow nr) * csqrt (er pow nr)) * cl * csqrt (el pow nl) *
 csqrt (el pow nl) + --(cl * csqrt (el pow nl) * csqrt (el pow nl)) -
 cr * csqrt (er pow nr) * csqrt (er pow nr)) + ((--ii * s1) * csqrt (csqrt (e pow n)) *
 cr * csqrt (csqrt (e pow n)) * c2 * csqrt (csqrt (e pow n)) * (--ii * sl) *
 csqrt (el pow nl) * csqrt (el pow nl) * (--ii * sl) * csqrt (csqrt (e pow n)) *
 --ii * s1) * (Cx (&1) + --(cr * csqrt (er pow nr) * csqrt (er pow nr))) +
 ((--ii * s1) * csqrt (csqrt (e pow n)) * (--ii * sr) * csqrt (er pow nr) *
 csqrt (er pow nr) * (--ii * sr) * csqrt (csqrt (e pow n)) * c2 *
 csqrt (csqrt (e pow n)) * cl * csqrt (csqrt (e pow n)) * --ii *
 s1) * (Cx (&1) + --(cl * csqrt (el pow nl) * csqrt (el pow nl))) +
 ((--ii * s1) * csqrt (csqrt (e pow n)) * (--ii * sr) *
 csqrt (er pow nr) * csqrt (er pow nr) * (--ii * sr) * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * (--ii * sl) * csqrt (el pow nl) *
 csqrt (el pow nl) * (--ii * sl) * csqrt (csqrt (e pow n)) * --ii * s1) *
 Cx (&1) = c1 * (Cx (&1) +  cl * cr * csqrt (er pow nr) pow 2 * 
 csqrt (el pow nl) pow 2 - cl * csqrt (el pow nl) pow 2 -
 cr * csqrt (er pow nr) pow 2)  + c2 * ((csqrt (csqrt (e pow n))) pow 2) pow 2 * (
 (c1 pow 2 + s1 pow 2) * (cr pow 2 + sr pow 2) * cl * csqrt (er pow nr) pow 2 +
 (c1 pow 2 + s1 pow 2) * (cl pow 2 + sl pow 2) * cr * csqrt (el pow nl) pow 2 
  - (c1 pow 2 + s1 pow 2) * cr * cl - (c1 pow 2 + s1 pow 2) * 
  (cl pow 2 + sl pow 2) * (cr pow 2 + sr pow 2) * 
  csqrt (er pow nr) pow 2 * csqrt (el pow nl) pow 2) /\
 (Cx (&1) + ((c1 * csqrt (csqrt (e pow n)) * cr * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * cl * csqrt (csqrt (e pow n))) * cr *
 csqrt (er pow nr) * csqrt (er pow nr) + (c1 * csqrt (csqrt (e pow n)) *
 cr * csqrt (csqrt (e pow n)) * c2 * csqrt (csqrt (e pow n)) * cl *
 csqrt (csqrt (e pow n))) * cl * csqrt (el pow nl) * csqrt (el pow nl)) +
 --Cx (&0) - (c1 * csqrt (csqrt (e pow n)) * cr * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * cl * csqrt (csqrt (e pow n))) * (cr * 
 csqrt (er pow nr) * csqrt (er pow nr)) * cl * csqrt (el pow nl) *
 csqrt (el pow nl) + ((c1 * csqrt (csqrt (e pow n)) * cr *
 csqrt (csqrt (e pow n)) * c2 * csqrt (csqrt (e pow n)) * (--ii * sl) *
 csqrt (el pow nl) * csqrt (el pow nl) * (--ii * sl) * csqrt (csqrt (e pow n))) *
 cr * csqrt (er pow nr) * csqrt (er pow nr) + --Cx (&0) + ((c1 *
 csqrt (csqrt (e pow n)) * (--ii * sr) * csqrt (er pow nr) * csqrt (er pow nr) *
 (--ii * sr) * csqrt (csqrt (e pow n)) * c2 * csqrt (csqrt (e pow n)) *
 cl * csqrt (csqrt (e pow n))) * cl * csqrt (el pow nl) * csqrt (el pow nl) +
 --Cx (&0) + ((cr * csqrt (er pow nr) * csqrt (er pow nr)) *  cl *
 csqrt (el pow nl) * csqrt (el pow nl) + --(cl * csqrt (el pow nl) * 
 csqrt (el pow nl)) - cr * csqrt (er pow nr) * csqrt (er pow nr)) -
 c1 * csqrt (csqrt (e pow n)) * (--ii * sr) * csqrt (er pow nr) *
 csqrt (er pow nr) * (--ii * sr) * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * (--ii * sl) * csqrt (el pow nl) *
 csqrt (el pow nl) * (--ii * sl) * csqrt (csqrt (e pow n)) - c1 *
 csqrt (csqrt (e pow n)) * (--ii * sr) * csqrt (er pow nr) *
 csqrt (er pow nr) * (--ii * sr) * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * cl * csqrt (csqrt (e pow n))) -
 c1 * csqrt (csqrt (e pow n)) * cr * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * (--ii * sl) * csqrt (el pow nl) *
 csqrt (el pow nl) * (--ii * sl) * csqrt (csqrt (e pow n))) -
 c1 * csqrt (csqrt (e pow n)) * cr * csqrt (csqrt (e pow n)) *
 c2 * csqrt (csqrt (e pow n)) * cl * csqrt (csqrt (e pow n)))
  = (Cx (&1) - cl * csqrt (el pow nl) pow 2 - cr * csqrt (er pow nr) pow 2 - 
  cr * cl * c1 * c2 * ((csqrt (csqrt (e pow n))) pow 2) pow 2
   + cl * cr * csqrt (er pow nr) pow 2 * csqrt (el pow nl) pow 2 +
  (cr pow 2 + sr pow 2) * cl * c1 * c2 * csqrt (er pow nr) pow 2 * 
  ((csqrt (csqrt (e pow n))) pow 2) pow 2 +
  (cl pow 2 + sl pow 2) * cr * c1 * c2 * csqrt (el pow nl) pow 2 * 
  ((csqrt (csqrt (e pow n))) pow 2) pow 2 -
  (cr pow 2 + sr pow 2) * (cl pow 2 + sl pow 2) * c1 * c2 * csqrt (er pow nr) pow 2 * 
  csqrt (el pow nl) pow 2 * ((csqrt (csqrt (e pow n))) pow 2) pow 2)`;;
	
	
	
let panda_through = prove(`(c1 pow 2 + s1 pow 2) = Cx(&1) /\ (cr pow 2 + sr pow 2) = Cx(&1) /\ 
(c2 pow 2 + s2 pow 2) = Cx(&1)  /\ (cl pow 2 + sl pow 2) = Cx(&1) ==>
SFG_Main ([1,c1,3;1,-- ii * s1,4;2,c1,4;2,-- ii * s1,3;4,csqrt (csqrt ((e:complex) pow n)),9;
9,cr,10;9,-- ii * sr,12;12,csqrt ((er:complex) pow nr),13;13,csqrt ((er:complex) pow nr),11;
11,-- ii * sr,10;11,cr,12;10,csqrt (csqrt ((e:complex) pow n)),5;5,c2,7;5,-- ii * s2,8;6,c2,8;
6,-- ii * s2,7;7,csqrt (csqrt ((e:complex) pow n)),14;14,cl,15;14,-- ii * sl,17;17,csqrt ((el:complex) pow nl),18;
18,csqrt ((el:complex) pow nl),16;16,cl,17;16,-- ii * sl,15;15,csqrt (csqrt ((e:complex) pow n)),2], 18, 3,1) = 
(c1 * (Cx (&1) + cl * cr * er pow nr * el pow nl - cl * el pow nl - cr * er pow nr) +
c2 * e pow n * (cl * er pow nr + cr * el pow nl - cr * cl - er pow nr * el pow nl)) /
 (Cx (&1) - cl * el pow nl - cr * er pow nr - cr * cl * c1 * c2 * e pow n +
 cl * cr * er pow nr * el pow nl + cl * c1 * c2 * er pow nr * e pow n +
 cr * c1 * c2 * el pow nl * e pow n - c1 * c2 * er pow nr * el pow nl * e pow n)`,
 SFG_TAC THEN SIMP_TAC [ COMPLEX_ADD_LID;COMPLEX_ADD_RID;COMPLEX_MUL_RZERO;
 COMPLEX_MUL_LZERO;COMPLEX_SUB_LZERO;COMPLEX_SUB_RZERO] THEN
SIMP_TAC[CSQRT;panda_help;COMPLEX_MUL_LID]);;



let panda_drop = prove( `(c1 pow 2 + s1 pow 2) = Cx(&1) /\ (cr pow 2 + sr pow 2) = Cx(&1) /\ 
(c2 pow 2 + s2 pow 2) = Cx(&1)  /\ (cl pow 2 + sl pow 2) = Cx(&1) ==>
SFG_Main ([1,c1,3;1,-- ii * s1,4;2,c1,4;2,-- ii * s1,3;4,csqrt (csqrt ((e:complex) pow n)),9;
9,cr,10;9,-- ii * sr,12;12,csqrt ((er:complex) pow nr),13;13,csqrt ((er:complex) pow nr),11;
11,-- ii * sr,10;11,cr,12;10,csqrt (csqrt ((e:complex) pow n)),5;5,c2,7;5,-- ii * s2,8;6,c2,8;
6,-- ii * s2,7;7,csqrt (csqrt ((e:complex) pow n)),14;14,cl,15;14,-- ii * sl,17;17,csqrt ((el:complex) pow nl),18;
18,csqrt ((el:complex) pow nl),16;16,cl,17;16,-- ii * sl,15;15,csqrt (csqrt ((e:complex) pow n)),2], 18, 8,1) = 
(s1 * s2 * er pow nr * csqrt (e pow n) - s1 * s2 * cl * el pow nl * er pow nr * csqrt (e pow n) -
cr * s1 * s2 * csqrt (e pow n) + cr * cl * s1 * s2 * el pow nl * csqrt (e pow n)) /
(Cx (&1) - cl * el pow nl - cr * er pow nr - cr * cl * c1 * c2 * e pow n +
cl * cr * er pow nr * el pow nl + cl * c1 * c2 * er pow nr * e pow n +
cr * c1 * c2 * el pow nl * e pow n - c1 * c2 * er pow nr * el pow nl * e pow n)`,
SFG_TAC THEN SIMP_TAC [ COMPLEX_ADD_LID;COMPLEX_ADD_RID;COMPLEX_MUL_RZERO;
 COMPLEX_MUL_LZERO;COMPLEX_SUB_LZERO;COMPLEX_SUB_RZERO] THEN
SIMP_TAC[CSQRT;panda_help;COMPLEX_MUL_LID]);;
 
 
 
 
 
(*-----------------------------------------------------*)
(*----------------Formalization------------------------*)
(*-----------------------------------------------------*)
(*-------------------------------------------------------------------*)
(*-------------------Z-Source Impedance Network----------------------*)
(*-------------------------------------------------------------------*)
 
 
 
let z_help =
 prove (`~(C*L=Cx(&0)) /\ ~(s =Cx(&0))   ==> 
(((G1 * Cx (&1) * Cx (&1) / (L * s) * DD * Cx (&1) * Cx (&1) / (C * s) *
 Cx (&2)) * (Cx (&1) + Cx (&0)) + (G2 * Cx (&1) * Cx (&1) / (C * s) * Cx (&2)) *
(Cx (&1) + Cx (&0) + Cx (&0) + Cx (&0) - Cx (&1) * Cx (&1) / (L * s) * G5) +
Cx (&0))  = Cx(&2) * (G2 * L * s + G1 * DD - G2 * G5)/ ( C * L * s pow 2) /\
((Cx (&1) +  Cx (&0) +  Cx (&0) +
(Cx (&0) + Cx (&0) + Cx (&0) - Cx (&1) * Cx (&1) / (L * s) * G5) -
Cx (&1) * Cx (&1) / (L * s) * DD * Cx (&1) * Cx (&1) / (C * s) * DD) =
( L * C * s pow 2 - G5 * C * s  - DD pow 2) / (C * L * s pow 2)) /\
(((DA * Cx (&1) *  Cx (&1) * Cx (&1) / (L * s) *DD *  Cx (&1) * Cx (&1) / (C * s) *
 Cx (&2)) * (Cx (&1) + Cx (&0)) +Cx (&0)) = Cx (&2) * DA * DD / (C * L * s pow 2)) /\
((((R * DA) * Cx (&1) * Cx (&1) / (L * s) * DD * Cx (&1) * Cx (&1) / (C * s) *
Cx (&2)) * (Cx (&1) + Cx (&0)) + (--DA * Cx (&1) * Cx (&1) / (C * s) * Cx (&2)) *
(Cx (&1) + Cx (&0) + Cx (&0) + Cx (&0) - Cx (&1) * Cx (&1) / (L * s) * G5) + Cx (&0)) =
-- Cx (&2) * DA * (L * s - R *  DD - G5) / (C * L * s pow 2)) /\
(((DA * Cx (&1) * Cx (&1) / (L * s) * DD * Cx (&1) * Cx (&1) * Cx (&1)) *
(Cx (&1) + Cx (&0)) + (DA * Cx (&1) * Cx (&1) / (L * s) * Cx (&1) * Cx (&1)) *
(Cx (&1) + Cx (&0)) + Cx (&0)) = DA * (Cx (&1) + DD) * C * s / (C * L * s pow 2)) /\ 
((Cx (&2) * Cx (&1) / (C * s) * Cx (&1) * G2) *
 (Cx (&1) + Cx (&0) + Cx (&0) + Cx (&0) - G5 * Cx (&1) / (L * s) * Cx (&1)) +
 (Cx (&2) * Cx (&1) / (C * s) * Cx (&1) * DD * Cx (&1) / (L * s) *
 Cx (&1) * G1) * (Cx (&1) + Cx (&0)) +
  Cx (&0)) = Cx (&2) * (G2 * L * s + DD * G1 - G2 * G5) / (L*C * s pow 2) /\ 
 (Cx (&1) + Cx (&0) + Cx (&0) + (Cx (&0) +  Cx (&0) +  Cx (&0) -
 DD * Cx (&1) / (C * s) * Cx (&1) * DD * Cx (&1) / (L * s) * Cx (&1)) -
 G5 * Cx (&1) / (L * s) * Cx (&1)) = (L * C * s pow 2 - G5 * C * s - DD pow 2)/(L*C * s pow 2))
`, CONV_TAC COMPLEX_FIELD);;


let z_circuit_vsum_Ds = prove ( 
 `~(C*L=Cx(&0)) /\ ~(s =Cx(&0)) ==> 
SFG_Main ([1,G1,4;1,G2,7;2,DA,4;3,R*DA,4; 3,--DA,7;
4,Cx(&1),5;5,Cx(&1)/(L*s),6;6,G5,4;6,DD,7;6,Cx(&1),9;7,Cx(&1),8;8,Cx(&1),9;
8,Cx(&1)/(C*s),11;9,Cx(&1),10;11,DD,4;11,Cx(&2),12], 12, 12, 1) = 
Cx(&2) * (G2 * L * s + G1 * DD - G2 * G5)/
( L * C * s pow 2 - G5 * C * s  - DD pow 2) `,
SFG_TAC THEN SIMP_TAC [z_help] THEN CONV_TAC COMPLEX_FIELD);; 


let z_circuit_vsum_Ds_transpose = prove ( ` ~(C*L=Cx(&0)) /\ ~(s =Cx(&0)) ==> 
SFG_Main (SFG_TRANSPOSE ([1,G1,4;1,G2,7;2,DA,4;3,R*DA,4; 3,--DA,7;
4,Cx(&1),5;5,Cx(&1)/(L*s),6;6,G5,4;6,DD,7;6,Cx(&1),9;7,Cx(&1),8;8,Cx(&1),9;
8,Cx(&1)/(C*s),11;9,Cx(&1),10;11,DD,4;11,Cx(&2),12], 12, 12, 1)) = 
Cx(&2) * (G2 * L * s + G1 * DD - G2 * G5)/
( L * C * s pow 2 - G5 * C * s  - DD pow 2) `
REWRITE_TAC [SFG_TRANSPOSE;component_of_four;component_of_trpl;SFG_INVERSE] THEN
SFG_TAC THEN SIMP_TAC [z_help] THEN CONV_TAC COMPLEX_FIELD);; 



(*------------------------Transfer Functions-------------------------*)

let z_circuit_vsum_Vdc = prove ( 
 `~(C*L=Cx(&0)) /\ ~(s =Cx(&0)) ==> 
SFG_Main ([1,G1,4;1,G2,7;2,DA,4;3,R*DA,4; 3,--DA,7;
4,Cx(&1),5;5,Cx(&1)/(L*s),6;6,G5,4;6,DD,7;6,Cx(&1),9;7,Cx(&1),8;8,Cx(&1),9;
8,Cx(&1)/(C*s),11;9,Cx(&1),10;11,DD,4;11,Cx(&2),12], 12, 12, 2) = 
Cx (&2) * DA * DD / ( L * C * s pow 2 - G5 * C * s  - DD pow 2) `,
SFG_TAC THEN SIMP_TAC [z_help] THEN CONV_TAC COMPLEX_FIELD);; 


let z_circuit_vsum_Iload = prove ( 
 `~(C*L=Cx(&0)) /\ ~(s =Cx(&0)) ==> 
SFG_Main ([1,G1,4;1,G2,7;2,DA,4;3,R*DA,4; 3,--DA,7;
4,Cx(&1),5;5,Cx(&1)/(L*s),6;6,G5,4;6,DD,7;6,Cx(&1),9;7,Cx(&1),8;8,Cx(&1),9;
8,Cx(&1)/(C*s),11;9,Cx(&1),10;11,DD,4;11,Cx(&2),12], 12, 12, 3) = 
-- Cx (&2) * DA * (L * s - R *  DD - G5) /
( L * C * s pow 2 - G5 * C * s  - DD pow 2) `,
SFG_TAC THEN SIMP_TAC [z_help] THEN CONV_TAC COMPLEX_FIELD);; 



let z_circuit_Iin_Vdc = prove ( 
 `~(C*L=Cx(&0)) /\ ~(s =Cx(&0)) ==> 
SFG_Main ([1,G1,4;1,G2,7;2,DA,4;3,R*DA,4; 3,--DA,7;
4,Cx(&1),5;5,Cx(&1)/(L*s),6;6,G5,4;6,DD,7;6,Cx(&1),9;7,Cx(&1),8;8,Cx(&1),9;
8,Cx(&1)/(C*s),11;9,Cx(&1),10;11,DD,4;11,Cx(&2),12], 12, 10, 2) = 
DA * (Cx (&1) + DD) * C * s / (L * C * s pow 2 - G5 * C * s  - DD pow 2) `,
SFG_TAC THEN SIMP_TAC [z_help] THEN CONV_TAC COMPLEX_FIELD);; 


(*------------------------Stability and Resonance-------------------------*)

let z_circuit_SFG = define `z_circuit_SFG G1 G2 R DA L G5 DD C s = 
([1,G1,4;1,G2,7;2,DA,4;3,R*DA,4; 3,--DA,7;
4,Cx(&1),5;5,Cx(&1)/(L*s),6;6,G5,4;6,DD,7;6,Cx(&1),9;7,Cx(&1),8;8,Cx(&1),9;
8,Cx(&1)/(C*s),11;9,Cx(&1),10;11,DD,4;11,Cx(&2),12], 12, 12, 1)`;;


let NUM_OF_z_circuit  = prove (` ! G1 G2 R DA L G5 DD C s. ~(s=Cx(&0)) 
/\  ~(C*L =Cx(&0)) ==> NUMERATOR (z_circuit_SFG G1 G2 R DA L G5 DD C s)  =  
	Cx(&2) * (G2 * L * s + G1 * DD - G2 * G5)/(C*L* s pow 2)`,
REWRITE_TAC [z_circuit_SFG] THEN 
NUMERATOR_TAC
THEN CONV_TAC COMPLEX_FIELD);;

let DENOM_OF_z_circuit = 
      prove (` ! G1 G2 R DA L G5 DD C s. ~(s=Cx(&0)) /\ ~(C*L =Cx(&0)) ==> 
	  DENOMINATOR (z_circuit_SFG G1 G2 R DA L G5 DD C s) = 
	  (L * C * s pow 2 - G5 * C * s  - DD pow 2)/(C*L* s pow 2)`,
REWRITE_TAC [z_circuit_SFG] THEN 
DENOMINATOR_TAC
THEN CONV_TAC COMPLEX_FIELD);;

let help0 = prove( ` !z a1 a2 a0. 
z = (a1 + csqrt (a1 pow 2 + (Cx(&4)) * a2 * a0))/((Cx(&2)) * a2) 
/\ ~(a2 = Cx (&0)) ==> a2 * z pow 2 - a1 * z - a0 = Cx (&0)`,
REPEAT STRIP_TAC THEN ASM_REWRITE_TAC[] 
THEN SIMP_TAC[COMPLEX_POW_2;COMPLEX_POW_DIV] THEN 
SIMP_TAC [COMPLEX_ADD_LDISTRIB;COMPLEX_ADD_RDISTRIB] 
THEN REWRITE_TAC[GSYM COMPLEX_POW_2;COMPLEX_POW_INV;CSQRT] 
THEN REPEAT(POP_ASSUM MP_TAC) THEN  TRY(CONV_TAC COMPLEX_FIELD));;

let help1 = prove( ` !z a1 a2 a0. 
z = (a1 - csqrt (a1 pow 2 + (Cx(&4)) * a2 * a0))/((Cx(&2)) * a2) 
/\ ~(a2 = Cx (&0)) ==> a2 * z pow 2 - a1 * z - a0 = Cx (&0)`,
REPEAT STRIP_TAC THEN ASM_REWRITE_TAC[] 
THEN SIMP_TAC[COMPLEX_POW_2;COMPLEX_POW_DIV] THEN 
SIMP_TAC [COMPLEX_SUB_LDISTRIB;COMPLEX_SUB_RDISTRIB] 
THEN REWRITE_TAC[GSYM COMPLEX_POW_2;COMPLEX_POW_INV;CSQRT] 
THEN REPEAT(POP_ASSUM MP_TAC) THEN  TRY(CONV_TAC COMPLEX_FIELD));;

let z_circuit_resonance_conditions = prove(
` (norm ((G2 * G5 - G1 * DD)/(G2 * L)) <= &1) /\
	(~(C*L = Cx(&0))) /\ (~(G2 = Cx(&0))) /\
         (~((G2 * G5 - G1 * DD) = Cx(&0))) /\
        (norm ((G2 * G5 - G1 * DD) / (G2 * L) ) <= &1) 
	==> is_resonant (\s. z_circuit_SFG G1 G2 R DA L G5 DD C s) s 
	[(G2 * G5 - G1 * DD)/(G2 * L)]`,
	REWRITE_TAC [is_resonant;poles_in_unit_circle;
	are_valid_zeros;in_unit_circle;
	is_valid_zero;set_of_zeros;NUM_OF_z_circuit] THEN 
	REPEAT STRIP_TAC THEN ASM_REWRITE_TAC[] THEN 
	REPEAT (POP_ASSUM MP_TAC) THEN SIMP_TAC [] 
	THEN REPEAT (POP_ASSUM MP_TAC) 
	THEN REWRITE_TAC[IN_ELIM_THM]
THEN REPEAT (STRIP_TAC)
THEN SUBGOAL_THEN `~((G2 * G5 - G1 * DD)/(G2 * L)= Cx (&0))` ASSUME_TAC
 THEN REPEAT (POP_ASSUM MP_TAC)
THEN TRY(CONV_TAC COMPLEX_FIELD)
THEN REPEAT (POP_ASSUM MP_TAC) 
THEN SIMP_TAC[NUM_OF_z_circuit]
THEN CONV_TAC COMPLEX_FIELD);;


let z_circuit_stability_conditions = prove(  
`(~(C*L = Cx(&0))) /\ 
(norm ((G5 * C + csqrt ((G5 * C) pow 2 + (Cx(&4))*(L*C)*(DD pow 2))) 
/ ((Cx(&2))*L*C) ) <= &1) 
/\ (norm ((G5 * C - csqrt ((G5 * C) pow 2 + (Cx(&4))*(L*C)*(DD pow 2)))
 / ((Cx(&2))*L*C) ) <= &1) /\  
 ~((G5 * C + csqrt ((G5 * C) pow 2 + (Cx(&4))*(L*C)*(DD pow 2)))/ ((Cx(&2))*L*C) = Cx(&0)) 
/\  ~((G5 * C - csqrt ((G5 * C) pow 2 + (Cx(&4))*(L*C)*(DD pow 2)))/ ((Cx(&2))*L*C) = Cx(&0)) 
	==> is_stable (\s. z_circuit_SFG G1 G2 R DA L G5 DD C s) s 
	[(G5 * C + csqrt ((G5 * C) pow 2 + (Cx(&4))*(L*C)*(DD pow 2))) 
	/ ((Cx(&2))*L*C);
	(G5 * C - csqrt ((G5 * C) pow 2 + (Cx(&4))*(L*C)*(DD pow 2))) 
	/ ((Cx(&2))*L*C)]`,
REWRITE_TAC [is_stable;poles_in_unit_circle;
	are_valid_poles;in_unit_circle;
	is_valid_pole;set_of_poles] THEN 
	REPEAT STRIP_TAC THEN ASM_REWRITE_TAC[] THEN 
	REPEAT (POP_ASSUM MP_TAC) THEN
REWRITE_TAC[IN_ELIM_THM] THEN
SIMP_TAC[DENOM_OF_z_circuit] THEN
IMP_REWRITE_TAC [COMPLEX_FIELD ` ~( x1 * x2 = Cx(&0)) /\ ~( y = Cx(&0)) 
==> (  (z / (x1 * x2 * y pow 2) = Cx (&0)) <=> z = Cx(&0))`] THENL
[IMP_REWRITE_TAC[help0;COMPLEX_MUL_ASSOC] THEN
SIMP_TAC[COMPLEX_MUL_SYM] ;
IMP_REWRITE_TAC[help1;COMPLEX_MUL_ASSOC] THEN
SIMP_TAC[COMPLEX_MUL_SYM]]);;



(*--------------------------------------------------------------------*)